; punkoe
; camera.asm - gestion du deplacement de la camera et de la generation
; de la map

  section ".text"

  xdef GestionCamera

  include "punkoe.h"

; GestionCamera
; Gere le deplacement de la camera et la generation du niveau
GestionCamera:
  cmpi.w  #i_hcam,c_hcam(a3)
  blt.s   \FinGestionCamera
  subi.w  #i_hcam,c_hcam(a3)

  addq.w  #1,d7
  lea.l   hcam_mod24(a4),a2
  addq.w  #1,(a2)
  cmpi.w  #24,(a2)
  blt.s   \FinGestionCamera

  ; Il faut rajouter une ligne
    clr.w   (a2)+ ; hcam_mod24 = 0  ; a2 = nbmaxtrous
    addi.w  #24,d5 ; hmap += 24

  ; On decale tout vers le bas
    moveq.l #(10*4)/2-1,d0
    lea.l   10*5(a5),a0
    lea.l   10*4(a5),a1
    \DecaleMap:
      move.w  -(a1),-(a0)
      dbf     d0,\DecaleMap

  ; On ajoute une ligne pleine
    moveq.l #10-1,d1
    movea.l a5,a0
    \AjoutePlateForme:
      move.b  #1,(a0)+
      dbf     d1,\AjoutePlateForme

  ; On ajoute des trous alatoirement
    move.w  randseed(a4),d0
    mulu.w  #$3F41,d0
    addq.w  #1,d0

    move.w  d0,d1
    mulu.w  (a2),d1 ; d1 = nbmaxtrous * d1
    swap.w  d1 ; d1 appartient [ 0 ; nbmaxtrous [ (ou 0 si nbmaxtrous=0)

    movea.l a5,a0
    \AjouteTrous:
      move.w  d0,d2
      mulu.w  #$3F41,d2
      addq.w  #1,d2
      move.w  d2,d0
      mulu.w  #10,d2
      swap.w  d2
      clr.b   0(a0,d2.w)
      dbf     d1,\AjouteTrous

    move.w  d0,randseed(a4)
    cmpi.w  #12,(a2)
    bcc.s   \FinGestionCamera ; si nbmaxtrous >= 12
      addq.w  #1,(a2)

\FinGestionCamera:
  rts
